%define _unpackaged_files_terminate_build 0%{nil}
%define __os_install_post /usr/lib/rpm/brp-compress %{nil}
%define current_version 7.0.1

%define vzpkgenv_path	vz/pkgenv

%define environment	vzpkgenv417x64

%define __find_provides %{nil}
%define __os_install_post %{nil}

%define technologies    "x86_64 nptl"

%define pkgman_path     %{vzpkgenv_path}/rpm417x64
%define pkglist         64

Summary: Chroot environment for rpm-4.17.0
Name: vzpkgenv417x64
Version: %{current_version}
Release: 2%{?dist}
Group: System Environment/Base
License: GPL
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: fakeroot
ExclusiveArch: x86_64
AutoReq: 0
AutoProv: 0
Requires: ca-certificates

Source8: GMT
Source9: passwd

# Patched packages: rpm, dnf
Source100: audit-libs-3.0.6-1.fc36.x86_64.rpm
Source101: basesystem-11-12.fc35.noarch.rpm
Source102: bash-5.1.8-2.fc36.x86_64.rpm
Source103: bzip2-libs-1.0.8-9.fc35.x86_64.rpm
Source104: ca-certificates-2021.2.50-3.fc35.noarch.rpm
Source105: coreutils-9.0-2.fc36.x86_64.rpm
Source106: coreutils-common-9.0-2.fc36.x86_64.rpm
Source107: cracklib-2.9.6-27.fc36.x86_64.rpm
Source108: crypto-policies-20210917-1.gitc9d86d1.fc36.noarch.rpm
Source109: curl-7.79.1-2.fc36.x86_64.rpm
Source110: cyrus-sasl-lib-2.1.27-16.fc36.x86_64.rpm
Source111: dnf-4.9.0-1.fc36.noarch.rpm
Source112: dnf-data-4.9.0-1.fc36.noarch.rpm
Source113: elfutils-default-yama-scope-0.185-5.fc35.noarch.rpm
Source114: elfutils-libelf-0.185-5.fc35.x86_64.rpm
Source115: elfutils-libs-0.185-5.fc35.x86_64.rpm
Source116: expat-2.4.1-2.fc35.x86_64.rpm
Source117: fedora-gpg-keys-36-0.3.noarch.rpm
Source118: fedora-release-common-36-0.7.noarch.rpm
Source119: fedora-release-container-36-0.7.noarch.rpm
Source120: fedora-release-identity-container-36-0.7.noarch.rpm
Source121: file-libs-5.40-9.fc35.x86_64.rpm
Source122: filesystem-3.16-1.fc36.x86_64.rpm
Source123: findutils-4.8.0-4.fc35.x86_64.rpm
Source124: gawk-5.1.0-4.fc35.x86_64.rpm
Source125: gdbm-libs-1.20-2.fc35.x86_64.rpm
Source126: glib2-2.70.0-5.fc36.x86_64.rpm
Source127: glibc-2.34.9000-13.fc36.x86_64.rpm
Source128: glibc-common-2.34.9000-13.fc36.x86_64.rpm
Source129: glibc-minimal-langpack-2.34.9000-13.fc36.x86_64.rpm
Source130: gmp-6.2.0-7.fc36.x86_64.rpm
Source131: gnupg2-2.3.3-1.fc36.x86_64.rpm
Source132: gnutls-3.7.2-2.fc35.x86_64.rpm
Source133: gpgme-1.15.1-4.fc35.x86_64.rpm
Source134: grep-3.7-1.fc36.x86_64.rpm
Source135: gzip-1.10-5.fc35.x86_64.rpm
Source136: ima-evm-utils-1.3.2-4.fc36.x86_64.rpm
Source137: json-c-0.15-2.fc35.x86_64.rpm
Source138: keyutils-libs-1.6.1-3.fc35.x86_64.rpm
Source139: krb5-libs-1.19.2-3.fc36.x86_64.rpm
Source140: libacl-2.3.1-2.fc35.x86_64.rpm
Source141: libarchive-3.5.2-2.fc36.x86_64.rpm
Source142: libassuan-2.5.5-3.fc35.x86_64.rpm
Source143: libattr-2.5.1-3.fc35.x86_64.rpm
Source144: libblkid-2.37.2-1.fc36.x86_64.rpm
Source145: libbrotli-1.0.9-6.fc35.x86_64.rpm
Source146: libcap-2.48-3.fc35.x86_64.rpm
Source147: libcap-ng-0.8.2-7.fc36.x86_64.rpm
Source148: libcom_err-1.46.4-1.fc36.x86_64.rpm
Source149: libcomps-0.1.18-1.fc36.x86_64.rpm
Source150: libcurl-7.79.1-2.fc36.x86_64.rpm
Source151: libdb-5.3.28-50.fc36.x86_64.rpm
Source152: libdnf-0.64.0-1.fc36.x86_64.rpm
Source153: libeconf-0.4.0-2.fc35.x86_64.rpm
Source154: libffi-3.1-28.fc34.x86_64.rpm
Source155: libfsverity-1.4-5.fc36.x86_64.rpm
Source156: libgcc-11.2.1-1.fc35.x86_64.rpm
Source157: libgcrypt-1.9.4-1.fc36.x86_64.rpm
Source158: libgomp-11.2.1-1.fc35.x86_64.rpm
Source159: libgpg-error-1.42-3.fc35.x86_64.rpm
Source160: libidn2-2.3.2-3.fc36.x86_64.rpm
Source161: libksba-1.6.0-2.fc35.x86_64.rpm
Source162: libmodulemd-2.13.0-3.fc36.x86_64.rpm
Source163: libmount-2.37.2-1.fc36.x86_64.rpm
Source164: libnghttp2-1.45.1-1.fc36.x86_64.rpm
Source165: libnsl2-1.3.0-4.fc35.x86_64.rpm
Source166: libpsl-0.21.1-4.fc35.x86_64.rpm
Source167: libpwquality-1.4.4-6.fc36.x86_64.rpm
Source168: librepo-1.14.2-1.fc36.x86_64.rpm
Source169: libreport-filesystem-2.15.2-6.fc35.noarch.rpm
Source170: libselinux-3.3-0.rc3.1.fc36.x86_64.rpm
Source171: libsemanage-3.3-0.rc3.1.fc36.x86_64.rpm
Source172: libsepol-3.3-0.rc3.1.fc36.x86_64.rpm
Source173: libsigsegv-2.13-3.fc35.x86_64.rpm
Source174: libsmartcols-2.37.2-1.fc36.x86_64.rpm
Source175: libsolv-0.7.20-1.fc36.x86_64.rpm
Source176: libssh-0.9.6-1.fc36.x86_64.rpm
Source177: libssh-config-0.9.6-1.fc36.noarch.rpm
Source178: libstdc++-11.2.1-1.fc35.x86_64.rpm
Source179: libtasn1-4.16.0-6.fc35.x86_64.rpm
Source180: libtirpc-1.3.2-1.rc1.fc36.x86_64.rpm
Source181: libunistring-0.9.10-14.fc35.x86_64.rpm
Source182: libuuid-2.37.2-1.fc36.x86_64.rpm
Source183: libverto-0.3.2-2.fc35.x86_64.rpm
Source184: libxcrypt-4.4.26-4.fc36.x86_64.rpm
Source185: libxml2-2.9.12-6.fc35.x86_64.rpm
Source186: libyaml-0.2.5-6.fc35.x86_64.rpm
Source187: libzstd-1.5.0-2.fc35.x86_64.rpm
Source188: alternatives-1.19-1.fc35.x86_64.rpm
Source189: lua-libs-5.4.3-2.fc35.x86_64.rpm
Source190: lz4-libs-1.9.3-3.fc35.x86_64.rpm
Source191: mpdecimal-2.5.1-2.fc35.x86_64.rpm
Source192: mpfr-4.1.0-8.fc35.x86_64.rpm
Source193: ncurses-base-6.2-8.20210508.fc35.noarch.rpm
Source194: ncurses-libs-6.2-8.20210508.fc35.x86_64.rpm
Source195: nettle-3.7.3-2.fc35.x86_64.rpm
Source196: npth-1.6-7.fc35.x86_64.rpm
Source197: openldap-2.4.59-4.fc36.x86_64.rpm
Source198: openssl-libs-3.0.0-1.fc36.x86_64.rpm
Source199: openssl1.1-1.1.1l-1.fc36.x86_64.rpm
Source200: p11-kit-0.23.22-4.fc35.x86_64.rpm
Source201: p11-kit-trust-0.23.22-4.fc35.x86_64.rpm
Source202: pam-1.5.2-6.fc36.x86_64.rpm
Source203: pcre-8.45-1.fc36.x86_64.rpm
Source204: pcre2-10.38-1.fc36.x86_64.rpm
Source205: pcre2-syntax-10.38-1.fc36.noarch.rpm
Source206: popt-1.18-6.fc36.x86_64.rpm
Source207: publicsuffix-list-dafsa-20210518-2.fc35.noarch.rpm
Source208: python-pip-wheel-21.3-1.fc36.noarch.rpm
Source209: python-setuptools-wheel-57.4.0-1.fc35.noarch.rpm
Source210: python3-3.10.0-2.fc36.x86_64.rpm
Source211: python3-dnf-4.9.0-1.fc36.noarch.rpm
Source212: python3-gpg-1.15.1-4.fc35.x86_64.rpm
Source213: python3-hawkey-0.64.0-1.fc36.x86_64.rpm
Source214: python3-libcomps-0.1.18-1.fc36.x86_64.rpm
Source215: python3-libdnf-0.64.0-1.fc36.x86_64.rpm
Source216: python3-libs-3.10.0-2.fc36.x86_64.rpm
Source217: python3-rpm-4.17.0-1.fc36.1.x86_64.rpm
Source218: readline-8.1-3.fc35.x86_64.rpm
Source219: rootfiles-8.1-30.fc35.noarch.rpm
Source220: rpm-4.17.0-1.fc36.1.x86_64.rpm
Source221: rpm-build-libs-4.17.0-1.fc36.1.x86_64.rpm
Source222: rpm-libs-4.17.0-1.fc36.1.x86_64.rpm
Source223: rpm-sign-libs-4.17.0-1.fc36.1.x86_64.rpm
Source224: sed-4.8-8.fc35.x86_64.rpm
Source225: setup-2.13.9.1-2.fc35.noarch.rpm
Source226: shadow-utils-4.9-4.fc36.x86_64.rpm
Source227: sqlite-libs-3.36.0-4.fc36.x86_64.rpm
Source228: sudo-1.9.8-4.p2.fc36.x86_64.rpm
Source229: tar-1.34-2.fc35.x86_64.rpm
Source230: tpm2-tss-3.1.0-4.fc36.x86_64.rpm
Source231: tzdata-2021a-2.fc35.noarch.rpm
Source232: vim-minimal-8.2.3512-1.fc36.x86_64.rpm
Source233: xz-libs-5.2.5-7.fc35.x86_64.rpm
Source234: yum-4.9.0-1.fc36.noarch.rpm
Source235: zchunk-libs-1.1.15-3.fc36.x86_64.rpm
Source236: zlib-1.2.11-30.fc35.x86_64.rpm
Source237: libvzctl-vzlibexeconly-7.0.697.3-1.fc36.x86_64.rpm
# end

Source1000:	dnf-4.9.0-1.fc36.src.rpm
Source1001:	libvzctl-7.0.697.3-1.fc36.src.rpm
Source1002:	rpm-4.17.0-1.fc36.1.src.rpm
Source1003:	libdnf-0.64.0-1.fc36.src.rpm 
Source1004:	iptables-1.8.4-15.el8.3.src.rpm

%description
Chroot environment for execution Virtuozzo version of yum package

%prep

rm -rf $RPM_BUILD_DIR/%{environment}
%setup -q -Tc -n %{name}

%build

%define debug_package %{nil}

function parse_find() {
    while read rattr fname; do
	echo $fname >> files.lst
	echo $fname >> files.lst
	if [ "${fname%*.pyc}" != "${fname}" ]; then
	    echo %ghost ${fname/.\///%{pkgman_path}/} >> files.2lst
	else
	    echo $rattr ${fname/.\///%{pkgman_path}/} >> files.2lst
	fi
    done
}

for i in files.lst files.2lst; do
    rm -f $i || /bin/true
    touch $i
done

DIR=$RPM_BUILD_DIR/%{name}/%{environment}

mkdir -p $DIR/var/lock/rpm
mkdir -p $DIR/var/lib/rpm
mkdir -p $DIR/var/tmp
mkdir -p $DIR/dev
rpm --initdb --root $DIR >/dev/null 2>&1


for package in %{sources}
do
  if grep '\.rpm$' <<< $package
  then
    fakeroot rpm2cpio $package | unzstd | fakeroot cpio -idv || true
  fi
done

cp -fv ./usr/bin/rpm ./usr/lib/rpm
ln -s ./rpm ./usr/lib/rpm/rpmq
ln -s ./rpm ./usr/lib/rpm/rpmi
cp $RPM_SOURCE_DIR/passwd ./etc
cp $RPM_SOURCE_DIR/GMT ./etc/localtime

# Move /lib64 to usr/lib64 to avoid conflist on upgrade
#mv -f ./lib64/* ./usr/lib64/
rm -rf ./lib64
ln -s usr/lib64 lib64

mkdir -p ./var/lib/rpm

# Create empty nssdb
rm -f ./etc/pki/nssdb/*

mkdir -p ./usr/share/vzyum/bin
mv ./usr/bin/dnf-3 ./usr/share/vzyum/bin/yum
#PSBM-127548
cp /etc/protocols ./etc/protocols
cp /etc/services ./etc/services

find ./var/lib/rpm -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/libexec -name platform-python\*  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name rpmdb  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name bash  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name curl  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name python3  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name python3.10  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name sh  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/sbin -name nft  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/sbin -name xtables-nft-multi  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/sbin -name iptables  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/share/vzyum/bin -name yum  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib -name \*.py\*  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib64 -name \*.py\*  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc/rpm -name platform -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc -name passwd -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc -name protocols -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc -name services -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc -name localtime -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./lib -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./lib64 -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./dev/urandom -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib/rpm/ -type f  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib/rpm/ -type l  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find . -name \*.so  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find . -name \*.so.*  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/include/python3.10m/ -name \*.h  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib64/python3.10/config-3.10m-x86_64-linux-gnu -name Makefile  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc/pki/ -type d  -printf '%%%attr(%m,root,root) %p\n' | parse_find


%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{pkgman_path}

# PSBM-125491
mkdir -p %{buildroot}/%{pkgman_path}/proc
mkdir -p %{buildroot}/%{pkgman_path}/tmp
mkdir -p %{buildroot}/%{pkgman_path}/dev
# end

tar --files-from=files.lst -cf - | tar --directory %buildroot/%{pkgman_path} -xf - 

echo "%technologies" > %{buildroot}/%{pkgman_path}/technologies
echo "%attr(644,root,root) /%{pkgman_path}/technologies" >> files.2lst

for i in `find %{buildroot} -type d | sed "s,^%{buildroot},,g"`; do
	if [ $i != "/vz" ] && [ $i != "/vz/pkgenv" ]; then
		echo "%attr(0755, root, root) %dir $i" >> files.2lst
	fi
done


%clean
rm -rf $RPM_BUILD_DIR/%{environment}

%postun
if [ $1 -eq 0 ]; then
	rm -rf /%{pkgman_path} >/dev/null 2>&1
fi

%files -f files.2lst

%changelog
* Tue Aug 5 2021 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-18
- fix for #PSBM-132616, rebuild iptables
